﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using DocumentFormat.OpenXml;
using DocumentFormat.OpenXml.Packaging;
using DocumentFormat.OpenXml.Wordprocessing;

namespace Open_XML
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonErstellen_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                WordprocessingDocument dokument = WordprocessingDocument.Create(saveFileDialog1.FileName, WordprocessingDocumentType.Document);
                MainDocumentPart hauptteil = dokument.AddMainDocumentPart();
                hauptteil.Document = new Document();

                Body body = hauptteil.Document.AppendChild(new Body());

                Paragraph absatz = body.AppendChild(new Paragraph());
                Run lauf = absatz.AppendChild(new Run());
                lauf.AppendChild(new Text("Ein neues Word-Dokument."));

                dokument.Close();
            }
        }

        private void buttonEinfuegen_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                WordprocessingDocument dokument = WordprocessingDocument.Open(openFileDialog1.FileName, true);

                Body body = dokument.MainDocumentPart.Document.Body;

                Paragraph para = body.AppendChild(new Paragraph());
                Run run = para.AppendChild(new Run());
                run.AppendChild(new Text(textBoxTextEinfuegen.Text));

                dokument.Close();
            }
        }

        private void buttonBearbeiten_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                WordprocessingDocument dokument = WordprocessingDocument.Open(openFileDialog1.FileName, true);

                Body body = dokument.MainDocumentPart.Document.Body;

                Paragraph absatz = body.Elements<Paragraph>().ElementAt(Convert.ToInt32(textBoxAbsatz.Text) - 1);
                Run lauf = absatz.Elements<Run>().First();
                Text text = lauf.Elements<Text>().First();
                text.Text = textBoxTextBearbeiten.Text;

                dokument.Close();
            }
        }
    }
}
