﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Excel = Microsoft.Office.Interop.Excel;

namespace Excel_Grundlagen
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonArbeitsmappeErstellen_Click(object sender, EventArgs e)
        {
            Excel.Application anwendung = new Excel.Application();
            Excel.Workbook arbeitsmappe = anwendung.Workbooks.Add();
            Excel.Worksheet arbeitsblatt = arbeitsmappe.Worksheets["Tabelle1"];
            
            Excel.Range zelle = arbeitsblatt.Range["A1"];
            for (int i = 0; i < 10; i++)
            {
                zelle.Offset[i, 0].Value2 = i + 1;
            }
            
            zelle = arbeitsblatt.Range["C1"];
            zelle.Value2 = 10;
            zelle.Offset[1, 0].Value2 = 20;
            Excel.Range bereich = arbeitsblatt.Range["C1:C2"];
            bereich.AutoFill(arbeitsblatt.Range["C1:C10"], Excel.XlAutoFillType.xlFillSeries);

            zelle = arbeitsblatt.Range["E1"];
            zelle.Name = "Bezeichner";

            Excel.Range benannt = arbeitsblatt.Range["Bezeichner"];
            benannt.Value2 = 100;
            benannt.Offset[1, 0].Value2 = 200;
            bereich = arbeitsblatt.Range["E1:E2"];
            bereich.AutoFill(arbeitsblatt.Range["E1:E10"], Excel.XlAutoFillType.xlFillSeries);

            arbeitsmappe.SaveAs(@"D:\Arbeitsmappe.xlsx");
            arbeitsmappe.Close();

            anwendung.Quit();
        }

        private void buttonDatenbalken_Click(object sender, EventArgs e)
        {
            //Gemeinsamer Code - Arbeitsmappe öffnen
            Excel.Application anwendung = new Excel.Application();
            Excel.Workbook arbeitsmappe = anwendung.Workbooks.Open(@"D:\Arbeitsmappe.xlsx");
            Excel.Worksheet arbeitsblatt = arbeitsmappe.Worksheets["Tabelle1"];
            //Gemeinsamer Code - Arbeitsmappe öffnen

            //Individueller Code
            Excel.Databar datenbalken = arbeitsblatt.Range["A1:A10"].FormatConditions.AddDatabar();
            datenbalken.MinPoint.Modify(Excel.XlConditionValueTypes.xlConditionValueNumber, 2);
            datenbalken.MaxPoint.Modify(Excel.XlConditionValueTypes.xlConditionValueNumber, 8);

            Excel.FormatColor fuellfarbe = datenbalken.BarColor;
            fuellfarbe.Color = 0x00FF0000;
            fuellfarbe.TintAndShade = 0;

            //Gemeinsamer Code - Arbeitsmappe speichern und schließen
            arbeitsmappe.Save();
            arbeitsmappe.Close();

            anwendung.Quit();
            //Gemeinsamer Code - Arbeitsmappe speichern und schließen
        }

        private void buttonFarbskala_Click(object sender, EventArgs e)
        {
            //Gemeinsamer Code - Arbeitsmappe öffnen
            Excel.Application anwendung = new Excel.Application();
            Excel.Workbook arbeitsmappe = anwendung.Workbooks.Open(@"D:\Arbeitsmappe.xlsx");
            Excel.Worksheet arbeitsblatt = arbeitsmappe.Worksheets["Tabelle1"];
            //Gemeinsamer Code - Arbeitsmappe öffnen

            //Individueller Code
            Excel.ColorScale farbskala = arbeitsblatt.Range["C1:C10"].FormatConditions.AddColorScale(2);
            farbskala.ColorScaleCriteria[1].FormatColor.Color = 0x000000FF;
            farbskala.ColorScaleCriteria[2].FormatColor.Color = 0x0000FF00;

            //Gemeinsamer Code - Arbeitsmappe speichern und schließen
            arbeitsmappe.Save();
            arbeitsmappe.Close();

            anwendung.Quit();
            //Gemeinsamer Code - Arbeitsmappe speichern und schließen
        }

        private void buttonSymbolsatz_Click(object sender, EventArgs e)
        {
            //Gemeinsamer Code - Arbeitsmappe öffnen
            Excel.Application anwendung = new Excel.Application();
            Excel.Workbook arbeitsmappe = anwendung.Workbooks.Open(@"D:\Arbeitsmappe.xlsx");
            Excel.Worksheet arbeitsblatt = arbeitsmappe.Worksheets["Tabelle1"];
            //Gemeinsamer Code - Arbeitsmappe öffnen

            //Individueller Code
            Excel.IconSetCondition symbolsatz = arbeitsblatt.Range["E1:E10"].FormatConditions.AddIconSetCondition();
            symbolsatz.IconSet = arbeitsmappe.IconSets[Excel.XlIconSet.xl3Arrows];
            symbolsatz.IconCriteria[2].Type = Excel.XlConditionValueTypes.xlConditionValueNumber;
            symbolsatz.IconCriteria[2].Value = 400;
            symbolsatz.IconCriteria[2].Operator = (int)(Excel.XlFormatConditionOperator.xlGreaterEqual);
            symbolsatz.IconCriteria[3].Type = Excel.XlConditionValueTypes.xlConditionValueNumber;
            symbolsatz.IconCriteria[3].Value = 700;
            symbolsatz.IconCriteria[3].Operator = (int)(Excel.XlFormatConditionOperator.xlGreaterEqual);

            //Gemeinsamer Code - Arbeitsmappe speichern und schließen
            arbeitsmappe.Save();
            arbeitsmappe.Close();

            anwendung.Quit();
            //Gemeinsamer Code - Arbeitsmappe speichern und schließen
        }
    }
}
