﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Office.Tools.Ribbon;
using System.Data;
using System.Data.OleDb;
using Excel = Microsoft.Office.Interop.Excel;
using VSTO = Microsoft.Office.Tools;

namespace Beispiel_3._5
{
    public partial class Ribbon1
    {
        private DataSet dataSet;
        private OleDbConnection oleDbConnection;
        private OleDbCommand oleDbCommand;
        private OleDbDataAdapter oleDbDataAdapter;
        private System.Windows.Forms.BindingSource bindingSource;

        private void Ribbon1_Load(object sender, RibbonUIEventArgs e)
        {

        }

        private void buttonImportieren_Click(object sender, RibbonControlEventArgs e)
        {
            dataSet = new DataSet();
            oleDbConnection = new OleDbConnection(@"Provider=SQLOLEDB.1; Data Source=.\SQLEXPRESS; Database=AdventureWorksDW2008; Integrated Security=SSPI;");

            string sql = "SELECT TOP 100 FirstName, LastName, AddressLine1, PostalCode, City, Phone, EmailAddress FROM dbo.ProspectiveBuyer";
            oleDbCommand = new OleDbCommand(sql, oleDbConnection);
            oleDbDataAdapter = new OleDbDataAdapter(oleDbCommand);
            oleDbDataAdapter.Fill(dataSet, "Kontakte");

            sql = "SELECT DATENAME(mm, [ReportingDate]) As Monat, Amount As Euro FROM dbo.vTimeSeries WHERE ModelRegion = 'M200 Europe' AND YEAR([ReportingDate]) = 2002";
            oleDbCommand = new OleDbCommand(sql, oleDbConnection);
            oleDbDataAdapter = new OleDbDataAdapter(oleDbCommand);
            oleDbDataAdapter.Fill(dataSet, "Umsatz");
        }

        private void buttonTabelle_Click(object sender, RibbonControlEventArgs e)
        {
            Excel.Worksheet arbeitsblatt = (Excel.Worksheet)Globals.ThisAddIn.Application.ActiveWorkbook.ActiveSheet;
            VSTO.Excel.Worksheet vstoArbeitsblatt = Globals.Factory.GetVstoObject(arbeitsblatt);
            Excel.Range zelle = arbeitsblatt.get_Range(editBoxZelle.Text);

            Microsoft.Office.Tools.Excel.ListObject kontakte;
            kontakte = vstoArbeitsblatt.Controls.AddListObject(zelle, "Kontakte");
            kontakte.AutoSetDataBoundColumnHeaders = true;
            kontakte.SetDataBinding(dataSet.Tables["Kontakte"]);

            arbeitsblatt.Columns.AutoFit();
        }

        private void buttonDatenbindung_Click(object sender, RibbonControlEventArgs e)
        {
            Excel.Worksheet arbeitsblatt = (Excel.Worksheet)Globals.ThisAddIn.Application.ActiveWorkbook.ActiveSheet;
            VSTO.Excel.Worksheet vstoArbeitsblatt = Globals.Factory.GetVstoObject(arbeitsblatt);
            Excel.Range aktiveZelle = Globals.ThisAddIn.Application.ActiveCell;

            bindingSource = new System.Windows.Forms.BindingSource();
            bindingSource.DataSource = dataSet.Tables["Kontakte"];
            VSTO.Excel.NamedRange vorname;
            VSTO.Excel.NamedRange nachname;

            vorname = vstoArbeitsblatt.Controls.AddNamedRange(aktiveZelle.get_Offset(0, 0), "Vorname");
            nachname = vstoArbeitsblatt.Controls.AddNamedRange(aktiveZelle.get_Offset(0, 1), "Nachname");
            vorname.DataBindings.Add("Value2", bindingSource, "FirstName", false);
            nachname.DataBindings.Add("Value2", bindingSource, "LastName", false);
        }

        private void buttonZurueck_Click(object sender, RibbonControlEventArgs e)
        {
            bindingSource.MovePrevious();
        }

        private void buttonWeiter_Click(object sender, RibbonControlEventArgs e)
        {
            bindingSource.MoveNext();
        }

        private void buttonDiagramm_Click(object sender, RibbonControlEventArgs e)
        {
            Excel.Worksheet arbeitsblatt = (Excel.Worksheet)Globals.ThisAddIn.Application.ActiveWorkbook.ActiveSheet;
            VSTO.Excel.Worksheet vstoArbeitsblatt = Globals.Factory.GetVstoObject(arbeitsblatt);
            Excel.Range zelle = vstoArbeitsblatt.Range["A4"];

            Microsoft.Office.Tools.Excel.ListObject umsatz;
            umsatz = vstoArbeitsblatt.Controls.AddListObject(zelle, "Umsatz");
            umsatz.AutoSetDataBoundColumnHeaders = true;
            umsatz.SetDataBinding(dataSet.Tables["Umsatz"]);

            VSTO.Excel.Chart diagramm = vstoArbeitsblatt.Controls.AddChart(150, 40, 300, 200, "Diagramm");
            diagramm.SetSourceData(umsatz.Range);
            diagramm.ChartTitle.Text = "Umsatz Europa 2002";
        }
    }
}
