﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace KontakteImportieren
{
    public partial class Form1 : Form
    {
        private DataSet dataSet;
        private OleDbConnection oleDbConnection;
        private OleDbCommand oleDbCommand;
        private OleDbDataAdapter oleDbDataAdapter;

        public Form1()
        {
            InitializeComponent();
        }

        public void KontakteAbfragen()
        {
            dataSet = new DataSet();

            oleDbConnection = new OleDbConnection(@"Provider=SQLOLEDB.1; Data Source=.\SQLEXPRESS; Database=AdventureWorksDW2008; Integrated Security=SSPI;");
            string sql = "SELECT TOP 100 CustomerKey, FirstName, LastName, AddressLine1, EmailAddress, Phone FROM dbo.DimCustomer";
            oleDbCommand = new OleDbCommand(sql, oleDbConnection);
            oleDbDataAdapter = new OleDbDataAdapter(oleDbCommand);
            oleDbDataAdapter.Fill(dataSet, "Kontakte");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            KontakteAbfragen();

            Outlook.Application anwendung = new Microsoft.Office.Interop.Outlook.Application();

            Outlook.Folder ordner = (Outlook.Folder)anwendung.Session.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderContacts);
            Outlook.Folder neuerOrdner = (Outlook.Folder)ordner.Folders.Add("AdventureWorksKontakte", Outlook.OlDefaultFolders.olFolderContacts);

            for (int i = 0; i < dataSet.Tables["Kontakte"].Rows.Count; i++)
            {
                Outlook.ContactItem neuerKontakt = (Outlook.ContactItem)neuerOrdner.Items.Add(Outlook.OlItemType.olContactItem);

                neuerKontakt.CustomerID = dataSet.Tables["Kontakte"].Rows[i]["CustomerKey"].ToString();
                neuerKontakt.FirstName = dataSet.Tables["Kontakte"].Rows[i]["FirstName"].ToString();
                neuerKontakt.LastName = dataSet.Tables["Kontakte"].Rows[i]["LastName"].ToString();
                neuerKontakt.BusinessAddressStreet = dataSet.Tables["Kontakte"].Rows[i]["AddressLine1"].ToString();
                neuerKontakt.Email1Address = dataSet.Tables["Kontakte"].Rows[i]["EmailAddress"].ToString();
                neuerKontakt.BusinessTelephoneNumber = dataSet.Tables["Kontakte"].Rows[i]["Phone"].ToString();

                neuerKontakt.Save();
            }

            MessageBox.Show(dataSet.Tables["Kontakte"].Rows.Count + " Kontakte wurden erfolgreich importiert.");
        }
    }
}
